' =============================================================================
' Levi.pb
' Levi-Fraktal, siehe Hans Lauwerier, Fraktale, Seite 51
' Erstellt am 03.07.13
'==============================================================================

#Include "Turtle.bas"

Dim As integer i, n = 2^12, k, d


Function SummeEinsen(k As Integer) As Integer
  'wandelt k in eine Binaerzahl um und gibt die Summe der darin enthaltenen Einsen zurck
  
  Dim As String s
  Dim As Integer Start, Pos1, Anz
    
  s = Bin(k)
  Start = 1
  Anz = 0
  Do
  	Pos1 = InStr(Start, s, "1")
  	If Pos1 > 0 Then
  		Anz = Anz + 1
  		Start = Pos1 + 1
  	Else
  		Exit do
  	EndIf
  Loop
  
  Return Anz
  
End Function


'----------------------------- Hauptprogramm: ---------------------------------

windowtitle "Levi-Fraktal"
screenres 640, 480
Color 4

TurtleX = 440
TurtleY = 320

d = 4
For i = 0 To n
  k = SummeEinsen(i)
  If k Mod 4 = 0 Then
    TurtleAngle = 0
  ElseIf k Mod 4 = 1 Then
    TurtleAngle = 90
  ElseIf k Mod 4 = 2 Then
    TurtleAngle = -180
  ElseIf k Mod 4 = 3 Then
    TurtleAngle = -90
  EndIf
  TurtleMove(d)
Next

GetKey
