'==============================================================================
' Baumfraktal.pb
' Erstellt am 03.07.13
'==============================================================================

#Include "Turtle.bas"
#Include "TUI.bas"

Dim Shared As Double angle
Dim Shared As integer delta, distance
Dim As String jn


sub DrawTree()
  'Baumfraktal (rekursiv)
  
  Dim As Integer d
  
  If (distance > 0) Then
    TurtleMove(distance)
    TurtleTurn(angle)
    d = distance
    distance = distance - delta
    DrawTree()
    TurtleTurn(-angle * 2)
    DrawTree()
    TurtleTurn(angle)
    distance = d
    TurtleMove(-distance)
  EndIf
  
End Sub

'--------------------------- Hauptprogramm: -------------------------------

angle = 30
delta = 10
distance = 80

Do
	
	'Dateneingabe:
	Screen 0
	Print "Baumfraktal - Parametereingabe:"
	Print 
	Print "Winkel in Grad: ";
	angle = Val(Edit(Str(angle), 10))
	Print "Distanz:        ";
	distance = Val(Edit(Str(distance), 10))
	Print "delta:          ";
	delta = Val(Edit(Str(delta), 10))
	 
	'Zeichnen:
	ScreenRes 500, 500
	Color 2
	TurtleAngle = 90
  TurtleX = 250
  TurtleY = 400
  DrawTree()
  
  Locate 62, 10
  Input "Noch einmal j/n: ", jn

Loop Until LCase(jn) = "n"

