' =============================================================================
' Drachenkurve.pb
' Siehe Hans Lauwerier, Fraktale, Seite 54
' Erstellt am 09.07.2013
'==============================================================================

#Include "Turtle.bas"

Dim As integer i, n = 2 ^ 14, d
Dim As Double angle(n) 

'Definition der Drehwinkel  nach jedem Schritt:

For i = 1 To n Step 4
  angle(i) = -90
Next
For i = 3 To n Step 4
  angle(i) = 90
Next
For i = 2 To n Step 2
  angle(i) = angle(i / 2)
Next

' Zeichnen:

WindowTitle "Drachenkurve"
ScreenRes 640, 480
Color 2

TurtleX = 150
TurtleY = 300
TurtleAngle = -90

d = 3
turtleMove(d)
For i = 1 To n
  TurtleTurn(angle(i))
  TurtleMove(d)
Next

GetKey
